﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HeuristicLab.Hive.Server.DataAccess;
using HeuristicLab.Hive.Server.LINQDataAccess;

namespace HeuristicLab.Hive.Server.Core {
  public class DaoLocator {
    
    [ThreadStatic] private static ISlaveDao clientDao;
    [ThreadStatic] private static ISlaveConfigDao clientConfigDao;
    [ThreadStatic] private static ISlaveGroupDao clientGroupDao;
    [ThreadStatic] private static IJobDao jobDao;
    [ThreadStatic] private static IPluginInfoDao pluginInfoDao;
    [ThreadStatic] private static IUptimeCalendarDao uptimeCalendarDao;
    [ThreadStatic] private static IHiveExperimentDao hiveExperimentDao;

    public static ISlaveDao SlaveDao {
      get {
        if (clientDao == null)
          clientDao = new SlaveDao();
        return clientDao;
      }
    }

    public static ISlaveConfigDao SlaveConfigDao {
      get {
        if(clientConfigDao == null)
          clientConfigDao = new SlaveConfigDao();
        return clientConfigDao;
      }
    }

    public static ISlaveGroupDao SlaveGroupDao {
      get {
        if(clientGroupDao == null)
          clientGroupDao = new SlaveGroupDao();
        return clientGroupDao;
      }
    }

    public static IJobDao JobDao {
      get {
        if(jobDao == null)
          jobDao = new JobDao();
        return jobDao;
      }
    }

    public static IPluginInfoDao PluginInfoDao {
      get {
        if(pluginInfoDao == null)
          pluginInfoDao = new PluginInfoDao();
        return pluginInfoDao;
      }
    }

    public static IUptimeCalendarDao UptimeCalendarDao {
      get {
        if (uptimeCalendarDao == null)
          uptimeCalendarDao = new UptimeCalendarDao();
        return uptimeCalendarDao;
      }
    }

    public static IHiveExperimentDao HiveExperimentDao {
      get {
        if (hiveExperimentDao == null)
          hiveExperimentDao = new HiveExperimentDao();
        return hiveExperimentDao;
      }
    }
  }
}
